<html>
<head>
<title>OgreGLSLESGpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_869fcd4d0767bf0c6544e0566078ca07.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_9c8668f5b14e7779923b4ed363e11a4e.html">GLSLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_84d626bd39fc7a71e1d66527f3ce1f64.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLESGpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLESGpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLSLESGpuProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLESGpuProgram_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSLESExtSupport_8h.html">OgreGLSLESExtSupport.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2GpuProgram_8h.html">OgreGLES2GpuProgram.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00048"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLES2GpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLES2GpuProgram</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">private</span>:
<a name="l00052"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a6cd401d00037a158c4707b7d32ae0de7">00052</a>         <a class="code" href="classOgre_1_1GLSLESProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgram</a>* <a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a6cd401d00037a158c4707b7d32ae0de7" title="GL Handle for the shader object.">mGLSLProgram</a>;
<a name="l00053"></a>00053 
<a name="l00055"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a909b82dce14efb9ce23fadc3bc43a389">00055</a>         <span class="keyword">static</span> GLuint <a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a909b82dce14efb9ce23fadc3bc43a389" title="Keep track of the number of vertex shaders created.">mVertexShaderCount</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a3188bfde70c6927f0a95418a9e03a497">00057</a>         <span class="keyword">static</span> GLuint <a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a3188bfde70c6927f0a95418a9e03a497" title="Keep track of the number of fragment shaders created.">mFragmentShaderCount</a>;
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html#adbf73e35f60ea60fff563eeefbefbf4e">00062</a>         GLint <a class="code" href="classOgre_1_1GLSLESGpuProgram.html#adbf73e35f60ea60fff563eeefbefbf4e" title="Flag indicating that the program object has been successfully linked.">mLinked</a>;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keyword">public</span>:
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>(<a class="code" href="classOgre_1_1GLSLESProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgram</a>* parent);
<a name="l00066"></a>00066         ~<a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>();
<a name="l00067"></a>00067 
<a name="l00069"></a>00069         <span class="keywordtype">void</span> bindProgram(<span class="keywordtype">void</span>);
<a name="l00071"></a>00071         <span class="keywordtype">void</span> unbindProgram(<span class="keywordtype">void</span>);
<a name="l00073"></a>00073         <span class="keywordtype">void</span> bindProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask);
<a name="l00075"></a>00075         <span class="keywordtype">void</span> bindProgramPassIterationParameters(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00076"></a>00076 
<a name="l00078"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a37176b52cca70c396b08d96acb71b9a3">00078</a>         <a class="code" href="classOgre_1_1GLSLESProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgram</a>* <a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a37176b52cca70c396b08d96acb71b9a3" title="Get the GLSLESProgram for the shader object.">getGLSLProgram</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGLSLProgram; }      
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a247be684e7c704f17f7dbaa603fbbe53">00083</a>         GLint <a class="code" href="classOgre_1_1GLSLESGpuProgram.html#a247be684e7c704f17f7dbaa603fbbe53" title="Return the programs link status Only used when programs are linked separately with GL_EXT_separate_sh...">isLinked</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mLinked; }
<a name="l00084"></a>00084 
<a name="l00088"></a><a class="code" href="classOgre_1_1GLSLESGpuProgram.html#ac333ea54c257d4d55cc65f72b94d3440">00088</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLSLESGpuProgram.html#ac333ea54c257d4d55cc65f72b94d3440" title="Set the programs link status Only used when programs are linked separately with GL_EXT_separate_shade...">setLinked</a>(GLint flag) { mLinked = flag; }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="keyword">protected</span>:
<a name="l00092"></a>00092         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00094"></a>00094         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00096"></a>00096         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00097"></a>00097     };
<a name="l00098"></a>00098 }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="preprocessor">#endif // __GLSLESGpuProgram_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
